//mutex/prodcons.c
#include <pthread.h>

#include <sys/types.h> 
#include <sys/stat.h> 
#include <wait.h> 
#include <fcntl.h> 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#define	MAXNITEMS 1000000
#define	MAXNTHREADS 100
#define	min(a,b)	((a) < (b) ? (a) : (b))

#define	max(a,b)	((a) > (b) ? (a) : (b))

static int nitems, potok=0;	/*       */
struct {
  pthread_mutex_t	mutex;
  int	buff[MAXNITEMS];
  int	nput;
  int	nval;
} shared = { 
	PTHREAD_MUTEX_INITIALIZER
};
void	*produce(void *), *consume(void *);
int
main(int argc, char **argv)
{
	int i, nthreads, count[MAXNTHREADS];
	pthread_t tid_produce[MAXNTHREADS], tid_consume;
	if (argc != 3) {

	printf("usage: prodcons <#items> <#threads>");
			exit(-1);

		}
	
	nitems = min(atoi(argv[1]), MAXNITEMS);
	nthreads = min(atoi(argv[2]), MAXNTHREADS);
	//Set_concurrency(nthreads);
		/*   - */
	for (i = 0; i < nthreads; i++) {
		count[i] = 0;
		pthread_create(&tid_produce[i], NULL, produce, &count[i]);
		potok++;
	}
		/*     */
	for (i = 0; i < nthreads; i++) {
		pthread_join(tid_produce[i], NULL);
		//printf("count[%d] = %d\n", i, count[i]);	
		printf("Producer #%lu makes %d elements\n", tid_produce[i], count[i]);	
	}
		/*     - */
	pthread_create(&tid_consume, NULL, consume, NULL);
	pthread_join(tid_consume, NULL);
	exit(0);
}
void *
produce(void *arg)
{
	sleep(rand()%1);
	for ( ; ; ) {
		pthread_mutex_lock(&shared.mutex);
		if (shared.nput >= nitems) {
			pthread_mutex_unlock(&shared.mutex);
			return(NULL);/* ,*/
		}
		shared.buff[shared.nput] = shared.nval;
		printf("Producer #%lu make element %d with value %d\n",pthread_self(),shared.nput,shared.nval);
		shared.nput++;
		shared.nval++;
		pthread_mutex_unlock(&shared.mutex);
		*((int *) arg) += 1;
	}
}
void *
consume(void *arg)
{
	int i;

	for (i = 0; i < nitems; i++) {
		if (shared.buff[i] != i)
			printf("buff[%d] = %d\n", i, shared.buff[i]);
	}
	return(NULL);
}
